package com.apl.test;

import java.net.URL;
import java.net.URLConnection;
import java.util.List;
import java.util.Map;

public class CookieTest {

	public static void main(String[] args) throws Exception {

		URL url = new URL("https://aglenergy.atlassian.net/rest/api/latest/issue/RP-12");
		URLConnection conn = url.openConnection();

		Map<String, List<String>> headerMap = conn.getHeaderFields();

		for (String headerKey : headerMap.keySet()) {
			List<String> headerValueList = headerMap.get(headerKey);

			if ("Set-Cookie".equalsIgnoreCase(headerKey)) {


				for (String headerValue : headerValueList) {

					System.out.println("Cookie Found...");

					String[] fields = headerValue.split("; *");

					String cookieValue = fields[0];
					String expires = null;
					String path = null;
					String domain = null;
					boolean secure = false;

					// Parse each field
					for (int j = 1; j < fields.length; j++) {
						if ("secure".equalsIgnoreCase(fields[j])) {
							secure = true;
						}
						else if (fields[j].indexOf('=') > 0) {
							String[] f = fields[j].split("=");
							if ("expires".equalsIgnoreCase(f[0])) {
								expires = f[1];
							}
							else if ("domain".equalsIgnoreCase(f[0])) {
								domain = f[1];
							}
							else if ("path".equalsIgnoreCase(f[0])) {
								path = f[1];
							}
						}

					}

					System.out.println("cookieValue:" + cookieValue);
					System.out.println("expires:" + expires);
					System.out.println("path:" + path);
					System.out.println("domain:" + domain);
					System.out.println("secure:" + secure);

					System.out.println("*****************************************");


				}

			}

		}

	}

}