/*
	APL Restful ARDBC Plugin
    Copyright 2015-2018  LJ LongWing - A Programming Legacy (http://remedylegacy.com)

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

package com.apl.test;

import java.util.HashMap;
import java.util.Map;

import com.apl.RestfulARDBCPlugin;
import com.bmc.arsys.api.ARException;
import com.bmc.arsys.api.Entry;
import com.bmc.arsys.api.Value;
import com.bmc.arsys.pluginsvr.plugins.ARPluginContext;

public class GenFieldsTest {
	public static void main(String[] args) throws ARException {
		Map<String, Object> fieldNameValueMap = new HashMap<>();
		fieldNameValueMap.put("Function", "GenFields");
		fieldNameValueMap.put("Input1", "AGGAA5V0H6VHKAOOHEODON1FWR7OKF");
		fieldNameValueMap.put("Input2", "Jira");
		fieldNameValueMap.put("Input3", "https://aglenergy.atlassian.net/rest/api/latest/issue/RP-12");
		fieldNameValueMap.put("Input4", "GET");
//		fieldNameValueMap.put("Input5", "{\r\n" + 
//				"\"fields\":\r\n" + 
//				" {\"project\":\r\n" + 
//				"   {\"key\":\"RCA\"},\r\n" + 
//				"   \"summary\":\"Jira Testing Incident Ticket\",\r\n" + 
//				"   \"description\":\"\",\r\n" + 
//				"   \"customfield_15109\":\"INC000006705413\",\r\n" + 
//				"   \"customfield_15110\":\"PBI000000048404\",\r\n" + 
//				"   \"issuetype\":\r\n" + 
//				"        {\"name\": \"Task\"},\r\n" + 
//				"    \"assignee\":\r\n" + 
//				"        {\"name\":\"nfoy\"},\r\n" + 
//				"     \"customfield_11411\": \"RCA-250\",\r\n" + 
//				"     \"labels\":[\"RCA\",\"TAS000000187019\"]\r\n" + 
//				"  }\r\n" + 
//				"}");
		
		RestfulARDBCPlugin plugin = new RestfulARDBCPlugin();
		ARPluginContext context = new ARPluginContext("APL", "1234", null);
		plugin.initialize(context);
		
		Entry entry = plugin.pluginFunctions(fieldNameValueMap, context, 0);
		
		for (java.util.Map.Entry<Integer, Value> key : entry.entrySet()) {
			System.out.println(key.getKey() + ": " + key.getValue());
		}
	}
}
