/*
	APL Restful ARDBC Plugin
    Copyright 2015-2018  LJ LongWing - A Programming Legacy (http://remedylegacy.com)

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

package com.apl.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.apl.Functions;
import com.apl.JSONParser;
import com.bmc.arsys.api.CharacterFieldLimit;
import com.bmc.arsys.api.Constants;
import com.bmc.arsys.pluginsvr.plugins.ARVendorField;

public class JSONTest {
	public static void main(String[] args) {
		List<ARVendorField> vendorFieldList = new ArrayList<ARVendorField>();
		vendorFieldList.add(new ARVendorField("ROOT:Data:urgency", -1, Constants.AR_DATA_TYPE_CHAR,
				new CharacterFieldLimit(0, Constants.AR_MENU_APPEND, Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		vendorFieldList.add(new ARVendorField("ROOT:Data:assignee_group", -1, Constants.AR_DATA_TYPE_CHAR,
				new CharacterFieldLimit(0, Constants.AR_MENU_APPEND, Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		vendorFieldList.add(new ARVendorField("ROOT:Data:impact", -1, Constants.AR_DATA_TYPE_CHAR,
				new CharacterFieldLimit(0, Constants.AR_MENU_APPEND, Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		vendorFieldList.add(new ARVendorField("ROOT:Data:status", -1, Constants.AR_DATA_TYPE_CHAR,
				new CharacterFieldLimit(0, Constants.AR_MENU_APPEND, Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		vendorFieldList.add(new ARVendorField("ROOT:Data:estimated_fix_date", -1, Constants.AR_DATA_TYPE_CHAR,
				new CharacterFieldLimit(0, Constants.AR_MENU_APPEND, Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		vendorFieldList.add(new ARVendorField("ROOT:Data:external_reference_id", -1, Constants.AR_DATA_TYPE_CHAR,
				new CharacterFieldLimit(0, Constants.AR_MENU_APPEND, Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		
		String fileName = "json.txt";
		InputStream is = null;
		JSONParser parser = null;
		try {
			is = new FileInputStream(new File(fileName));
			String output = Functions.processInputStream(is, "UTF-8");
			List<Integer> skipLevelList = new ArrayList<Integer>();
			//skipLevelList.add(1);
			
			parser = new JSONParser(vendorFieldList, "ROOT", -1, skipLevelList);
			parser.parse(output, ",");
		} catch (IOException e) {
			System.out.println("IOException: " + e.getMessage());
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (IOException e) {
					System.out.println("IOException: " + e.getMessage());					
				}
			}
		}
		
		Map<String, String> globalElementMap = parser.getGlobalElementMap();
		List<Map<String, String>> recordElementList = parser.getRecordElementList();

		if (globalElementMap != null)
			System.out.println("GlobalMap: " + globalElementMap.size());
		if (recordElementList != null)
			System.out.println("RecordMap: " + recordElementList.size());
			
		
		if (globalElementMap != null) {
			for (String element : globalElementMap.keySet()) {
				String value = globalElementMap.get(element);
				System.out.println("GlobalMap: " + element + " - " + value);
			}
		}
		if (recordElementList != null) {
			for (Map<String, String> recordElementMap : recordElementList) {
				System.out.println("Start Record");
				for (String element : recordElementMap.keySet()) {
					String value = recordElementMap.get(element);
					System.out.println("RecordMap: " + element + " - " + value);
				}
				System.out.println("End Record");
			}
		}
	}
}
