/*
	APL Restful ARDBC Plugin
    Copyright 2015-2018  LJ LongWing - A Programming Legacy (http://remedylegacy.com)

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

package com.apl.test;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.apl.Functions;

public class TemplateTest {

	public static void main(String[] args) {
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader("json.txt"));
		} catch (FileNotFoundException e1) {}
	    String line = null;
	    StringBuilder  stringBuilder = new StringBuilder();

	    try {
	        try {
				while((line = reader.readLine()) != null) {
				    stringBuilder.append(line + System.lineSeparator());
				}
			} catch (IOException e) {}
	    } finally {
	        try {
				reader.close();
			} catch (IOException e) {}
	    }		
		String template = stringBuilder.toString();
		
		//System.out.println(template);
		
		Map<String, Object> fieldNameValueMap = new HashMap<>();
		fieldNameValueMap.put("ROOT:OrderHeader:OrderId", "0");
		fieldNameValueMap.put("ROOT:OrderHeader:EffectiveDate", "09/10/2019");
		fieldNameValueMap.put("ROOT:OrderHeader:OrderName", "MRNITest");
		fieldNameValueMap.put("ROOT:OrderHeader:OrderType", "Initial");
		fieldNameValueMap.put("ROOT:OrderHeader:TaskOrderNumber", "string");
		fieldNameValueMap.put("ROOT:OrderHeader:Contract", "EUHWRNI");
		fieldNameValueMap.put("ROOT:OrderHeader:Status", "Status");
		fieldNameValueMap.put("ROOT:OrderHeader:Uic", "M00020");
		fieldNameValueMap.put("ROOT:OrderHeader:FiscalYear", "2019");
		fieldNameValueMap.put("ROOT:OrderHeader:Comment", "This is a task order test for RNI testing");
		fieldNameValueMap.put("ROOT:ServicesJson", "[{ \"Dodaac\": \"string\", \"ShippingPoc\": \"string\", \"RemedyId\": \"string\", \"ServiceId\": \"0\", \"FiscalYear\": \"2019\", \"ClinId\": \"string\", \"ServiceStartDate\": \"09/21/2019\", \"ServiceEndDate\": \"09/30/2019\", \"MappedServicesIds\": [0], \"AssetInformation\": { \"MachineName\": \"string\", \"AssetId\": \"string\", \"DeliveryDate\": \"\", \"SerialNumber\": \"string\", \"WallJack\": \"string\\\", \"Location\": { \"FourCode\": \"string\", \"Building\": \"string\", \"Floor\": \"1\", \"Room\": \"1\", \"Cubicle\": \"1\" } }, \"Uic\": \"string\", \"OperatingSystem\": \"\", \"Contract\": \"string\", \"Options\": [], \"ProfileId\": \"string\", \"OrderId\": \"0\", \"Status\": \"string\" }]");
		
		List<String> optionalList = new ArrayList<String>();
		optionalList.add("ROOT:Data:urgency");
		
		System.out.println("Template Before:" + template);

		String udatedTemplate = Functions.replaceTemplateValues(template, fieldNameValueMap, optionalList, null, "|");
		
		System.out.println("Template:" + udatedTemplate);
	}
}
